#include <iostream>
#include <vector>

using namespace std;

int main()
{
    int N,Q;
    cin >> N >> Q;
    long long kupljeno_dana[10000];
    long long zalihe_dana[10000];
    long long pojedeno_do_dana[10000];
    for(int i =0;i < N;i++)
    {
        long long dan,kolicina;
        cin >> dan >> kolicina;
        dan = dan-1;
        kupljeno_dana[dan] = kolicina;
    }
    for(long long i = 0; i < 10000;i++)
    {
        if(kupljeno_dana[i]>0)
        {

        }
        else
        {
            kupljeno_dana[i]=0;
        }
    }
    if(kupljeno_dana[0] <= 0)
    {
        zalihe_dana[0] = 0;
        pojedeno_do_dana[0] = 0;
    }
    else
    {
        zalihe_dana[0] = kupljeno_dana[0]-1;
        pojedeno_do_dana[0] = 1;
    }
    for(long long i =1;i < 10000;i++)
    {
        if((zalihe_dana[i-1] + kupljeno_dana[i]) > 0)
        {
           zalihe_dana[i] = zalihe_dana[i-1]+ kupljeno_dana[i]-1;
           pojedeno_do_dana[i] = pojedeno_do_dana[i-1]+1;
        }
        else
        {
            zalihe_dana[i] = 0;
            pojedeno_do_dana[i] = pojedeno_do_dana[i-1];
        }
    }
    for(int i =0; i < Q; i++)
    {
        long long dan_u_pitanju;
        cin >> dan_u_pitanju;
        dan_u_pitanju = dan_u_pitanju-1;
        cout << pojedeno_do_dana[dan_u_pitanju] << " ";
    }
    return 0;
}